;
; unrom menu
;

.linecont on ; разрыв строки по \
.feature c_comments; разрешение /* комментарий */

.include "nesdefs.inc"

RESET_OLD = $c001 ; старое значение вектора сброса
;OFFSET_LOAD = $1ff40 ; смещение на неиспользуемое место для кода переключения банка
OFFSET_MENU = $1f623 ; смещение на неиспользуемое место для кода меню


;ORG_LOAD = $c000 + (OFFSET_LOAD-$10) .mod $4000 ;
ORG_MENU = $c000 + (OFFSET_MENU-$10) .mod $4000 ;
NBANK_MENU = (OFFSET_MENU-$10) / $4000; номер банка с меню
;.assert (OFFSET_LOAD-$10) / $4000 = 7, error , "OFFSET_LOAD должен находиться в фиксированном банке"
.assert NBANK_MENU = 7, error, "Меню располагается в фиксированном банке"
.out .sprintf ("new reset = $%X", ORG_MENU)

; заголовок
.segment "INESHDR"
    INES_MAPPER = 2 ; 0 = NROM, 2 = UNROM
    INES_MIRROR = 0 ; 0 = horizontal mirroring, 1 = vertical mirroring
    INES_SRAM   = 0 ; 1 = battery backed SRAM at $6000-7FFF
    .byt "NES", $1A ; ID
    .byt 2 ; 16k PRG bank count
    .byt 0 ; 8k CHR bank count
    .byt INES_MIRROR | (INES_SRAM << 1) | ((INES_MAPPER & $f) << 4)
    .byt (INES_MAPPER & %11110000)

; векторы прерываний
.segment "VECTORS"
	.addr nmi_isr, reset, irq_isr

; переменные
.segment "ZEROPAGE"
joy1:           .res 1 ; состояние джойстика
joy1prv:       .res 1 ; предыдущее состояние
tmpvar:         .res 2 ; временная переменная


; код
.segment "CODE"

; прерывание nmi
.proc nmi_isr
    rti
.endproc

; прерывание irq
.proc irq_isr
	rti
.endproc


.org ORG_MENU
.proc reset
    sei
    ;cld

    lda #$ff
    tax
    txs ; указатель стека

	inx ; ldx #0
	stx PPU_CTRL		; запрет NMI
	stx PPU_MASK		; отключение спрайтов и фона
    
    ; ждем 2 vblank
    bit PPU_STATUS
:   bit PPU_STATUS
    bpl :-
:   bit PPU_STATUS
    bpl :-

    ; перемещаем все спрайты x=255,y=255
    ;ldx #0
	;lda #$ff
:	sta OAM_RAM, x
	inx
	bne :-
    ; настраиваем спрайт курсора
    sta OAM_RAM+0 ; у
    lda #'@'
    sta OAM_RAM+1 ; номер спрайта
    lda #%00010000 | 2 ; номер палитры 0-3
    sta OAM_RAM+2 ; атрибут
    lda #(8*4+4)
    sta OAM_RAM+3 ; x

    ; вызов DMA ; вызываем каждый кадр после опроса джойстика
	;lda #0
	;sta PPU_OAM_ADDR ; 
	;lda #>OAM_RAM
	;sta OAM_DMA


    ; загрузка палитры
    ldx #>$3F00
    stx PPU_ADDR
    ldx #<$3F00
    stx PPU_ADDR

    ;фона
	ldx #0
:	lda palette,x
	sta PPU_DATA
	inx
	cpx #16
	bcc :-

    ; спайтов, та же самая палитра
    ldx #0
:	lda palette,x
	sta PPU_DATA
	inx
	cpx #16
	bcc :-
    

    ; переключение банка UNROM с набором символов
    ; TODO:

    ; загрузка символов
    lda #0
    ;sty PPU_MASK
    sta PPU_ADDR
    sta PPU_ADDR

    ; 256*3 байт пустоты
    ldx #3 ; для 2bpp.chr
    ;ldx #4 ; для 1bpp.chr
    tay
:   sta PPU_DATA
    iny
    bne :-
    dex
    bne :-


    lda #<chr_tiles
    sta tmpvar
    lda #>chr_tiles
    sta tmpvar+1
    
    ; 768 байт тайлов 2bpp.chr
    ldx #3
    ldy #0
:   lda (tmpvar),y
    sta PPU_DATA
    iny
    bne :-
    inc tmpvar+1
    dex
    bne :-
    
    /*
    ; загрузка 1bpp 32 символа
    ldx #0
@chars_next:
    lda chr_tiles,x
    sta PPU_DATA
    inx
    beq @chars_done
    txa
    and #%111
    eor #%111
    bne @chars_next;  A mod 8 != 0
    ;lda #0
    ldy #8
:   sta PPU_DATA 
    dey
    bne :-
    beq @chars_next
@chars_done:
    */

    ; очистка первой экранной страницы
    ldx #>$2000
    stx PPU_ADDR
    ldx #<$2000
    stx PPU_ADDR
	lda #0
	ldx #32*30/4	; 32*30/4=960/4=240
:	sta PPU_DATA
	sta PPU_DATA
	sta PPU_DATA
	sta PPU_DATA
	dex
	bne :-

    ; палитра для первой строки, PPU_ADDR уже установлен
	ldx #8
	lda #%00000000	; палитра 0
:	sta PPU_DATA
	dex
	bne :-

    ; палитра для второй строки, PPU_ADDR установлен
	ldx #8
	lda #%10100101	; палитра 1
:	sta PPU_DATA
	dex
	bne :-

    ; палитра для все остальных строк, PPU_ADDR установлен
	ldx #(64-8-8)
	lda #%10101010
:	sta PPU_DATA
	dex
	bne :-

    ; загружаем текст меню в 1 страницу
    ldx #>$2000
    stx PPU_ADDR
    ldx #<$2000
    stx PPU_ADDR

    ; печатаем текст
    ;ldx #0 ; #<$2000 == #0

    ldy text_menu, x ; количество пробелов
@print_line:
    lda #' '
:   sta PPU_DATA
    dey
    bne :-

    inx
    ldy text_menu, x ; количество символов
:   inx
    lda text_menu, x ; символ
    sta PPU_DATA
    dey
    bne :-

    inx
    ldy text_menu, x ; количество пробелов
    bne @print_line ; пробелов 0 - конец


    ; включение PPU
	lda #BG_0|SPR_0|NT_0|VRAM_RIGHT
	sta PPU_CTRL

	; включение спрайтов и бекграунда
	lda #BG_ON|SPR_ON|HIDE_BG_LHS|HIDE_SPR_LHS
	sta PPU_MASK

    ldy #0 ; выбранный пункт
mainloop:
    
    ; чтение джойстика
    lda #$01
    sta $4016
    sta joy1
    lsr a        ; A=0
    sta $4016
:   lda $4016
    lsr a	    ; bit0 -> Carry
    rol joy1  ; Carry -> bit0; bit 7 -> Carry
    bcc :-


    ; фильтруем только нажатия
    lda joy1
    tax
    eor joy1prv
    and joy1
    stx joy1prv

    ; двигаем курсор
    ;bit:   	 7     6     5     4     3     2     1     0
    ;button:	 A     B  Select Start  Up   Down  Left  Right
    ror a ; 0bit Right
    ror a ; 1bit Left
    ror a ; 2bit Down
    bcc :+
    iny
:   ror a ; 3bit Up
    bcc :+
    dey
    ;bne :+ ; исключение первого пункта
    ;dey    ;  
:   ror a ; 4bit Start
    bcs launch ; запускаем игру

    tya
    and #%11 ; ограничиваем пунткы 0-3 (1-4)
    tay

    ; исключаем первый пункт для 3in1
    ;bne :+
    ;iny
;:   tya

    clc
    adc #$03 ; начинается с 7 строки экрана
    asl a ; a = a*16
    asl a
    asl a
    asl a
    ;clc
    adc #$05 ; курсор по центру строки



:   bit PPU_STATUS
    bpl :-

    sta OAM_RAM+0 ; позиция курсора по у
	lda #>OAM_RAM ; вызов DMA
	sta OAM_DMA


    jmp mainloop

launch:
    ; копируем лаунчер в озу
    ldx #23; количество байт в лаунчере
:   dex
    lda launcher, x
    sta tmpvar, x
    txa
    bne :-
    jmp tmpvar

launcher:
    ldx #4
    lda latch_bytes,x ; сбрасываем d4 (clk защелки)
    sta latch_bytes,x
    lda latch_bytes,y ; переключаем
    sta latch_bytes,y
    tya
    bne :+
    jmp RESET_OLD
:   jmp ($fffc)

palette:
    ; палитра
	.byt $0f, $19, $29, $39; зеленый
	.byt $0f, $18, $28, $38; оранжевый
	.byt $0f, $11, $21, $31; синий
	.byt $0f, $15, $25, $35; розовый

text_menu:
    ; количество пробелов, длинна строки, строка
    .byt 74, 12, "UNROM 4 IN 1"
    .byt 49, 18, "PUSH ^ _ START KEY"
    .byt 77, 8, "1:CONTRA"
    .byt 56, 13, "2:MEGAMAN RUS"
    .byt 51, 15, "3:GUN:SMOKE RUS"
    .byt 49, 17, "4:GHOST;N;GOBLINS"
    .byt 0    
.endproc


chr_tiles:
	.incbin "alnum.2bpp.chr"
	;.incbin "alnum.1bpp.chr"

;.org ORG_LOAD
; код переключения банка и передачи управления
;@chbank:
;    lda #NBANK_MENU
;    sta @chbank+1
;    jmp ORG_MENU

latch_bytes:
    ; bit   76543210
    ; block -BB1----
    .byt $10, $30, $50, $70, $00;



; vim:ft=a65:
